/*
 * usart6.c
 *
 *  Created on: 03.11.2012
 *      Author: AndreR
 */

#include "usart6.h"

#include "util/init_hal.h"
#include "../constants.h"

USART usart6;

void USART6_IRQHandler()
{
	USARTIRQ(&usart6);
}

void USART6Init()
{
	// enable peripheral clock
	RCC->APB2ENR |= RCC_APB2ENR_USART6EN;

	// provide data storage
	static uint8_t usart6TxData[USART6_FIFO_SIZE];
	static uint8_t usart6RxData[USART6_FIFO_SIZE];

	// map data and configure
	USARTData data;
	data.pDataRx = usart6RxData;
	data.rxSize = USART6_FIFO_SIZE;
	data.pDataTx = usart6TxData;
	data.txSize = USART6_FIFO_SIZE;
	data.maxPacketSize = USART6_MAX_PACKET_SIZE;
	data.pDMA = DMA2;
	data.dmaChannel = 5;
	data.rxStream = 1;
	data.txStream = 6;
	data.usartIRQn = USART6_IRQn;
	data.IRQL = IRQL_USART6;
	data.baudrate = 5250000;

	// Init USART util layer
	USARTInit(&usart6, USART6, data);

	// GPIO setup
	GPIOInitData gpioInit;
	gpioInit.mode = GPIO_MODE_AF;
	gpioInit.alternate = 8; 	// USART6
	gpioInit.otype = GPIO_OTYPE_PUSH_PULL;
	gpioInit.ospeed = GPIO_OSPEED_25MHZ;
	gpioInit.pupd = GPIO_PUPD_UP;
	GPIOInit(GPIOC, GPIO_PIN_6 | GPIO_PIN_7, &gpioInit);
}
