/*
 * skill_basics.h
 *
 *  Created on: 24.06.2015
 *      Author: AndreR
 */

#ifndef SKILL_BASICS_H_
#define SKILL_BASICS_H_

#include <main/skills.h>

#define BASIC_KD_KICK_FLAGS_DEVICE_MASK	0x01
#define BASIC_KD_KICK_FLAGS_EXTRA_MASK	0x0E
#define BASIC_KD_KICK_FLAGS_MODE_MASK	0xF0

#define GLOBAL_POS_MAX_VEL_XY	5.0f
#define GLOBAL_POS_MAX_VEL_W	30.0f
#define GLOBAL_POS_MAX_ACC_XY	10.0f
#define GLOBAL_POS_MAX_ACC_W	100.0f

#define LOCAL_VEL_MAX_ACC_XY	10.0f
#define LOCAL_VEL_MAX_ACC_W		100.0f
#define LOCAL_VEL_MAX_JERK_XY	100.0f
#define LOCAL_VEL_MAX_JERK_W	1000.0f

extern SkillInstance skillEmergency;
extern SkillInstance skillLocalVel;
extern SkillInstance skillGlobalVel;
extern SkillInstance skillGlobalPos;
extern SkillInstance skillWheelVel;
extern SkillInstance skillGlobalVelAndOrient;

typedef struct PACKED _BasicKDInput
{
	uint8_t kickSpeed;		// [0.04 m/s]
	uint8_t kickFlags;		// mode, dev
	uint8_t dribblerSpeed;	// [rpm/100]
} BasicKDInput;

typedef struct _EmergencyData
{
	float outVelLocal[3];
	float decrement[3];
} SkillEmergencyData;

extern SkillEmergencyData emergency;

void SkillBasicsParseKDInput(const SkillInput* pInput, const BasicKDInput* pKD, SkillOutput* pOutput);
void SkillBasicsParseAcquisitionMode(uint8_t mode, const SkillInput* pInput);

#endif /* SKILL_BASICS_H_ */
